Bug 123590 - Should be possible to customise menus or toolbars delivered with an extension
Summary: Should be possible to customise menus or toolbars delivered with an extension
Status: RESOLVED WONTFIX
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Writer (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: Customize-Dialog
  Show dependency treegraph
 
Reported: 2019-02-20 09:27 UTC by rolfofsaxony
Modified: 2019-03-06 13:42 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description rolfofsaxony 2019-02-20 09:27:27 UTC
Description:
Specifically in Writer but I suspect for all modules, Menus and Toolbars delivered with an extension are not included in the available options, when using Tools->Customise->Menus or Tools-Customise->Toolbars

The available options for the Menus seem to be hard-coded to the file:
~/.config/libreoffice/4/user/config/soffice.cfg/modules/swriter/menubar/menubar.xml

However, if you manually create a new menu, using Customise, using the macros defined within the extension, in effect, reproducing the extensions menu, that menu is written to the above file and becomes customisable.

In my view, Menus and Toolbars delivered with an extension, should be available for customisation.


Steps to Reproduce:
1.load an extension with either a menu or toolbar
2.using Tools->Customise attempt to customise it
3.

Actual Results:
The delivered and visible menu or toolbar will not be provided in the list of items to customise.

Expected Results:
I would expect to see the menu or toolbar as an option


Reproducible: Always


User Profile Reset: Yes



Additional Info:
Comment 1 Heiko Tietze 2019-02-21 11:09:34 UTC
Think this is not possible. What's your take, Muhammet?
Comment 2 Heiko Tietze 2019-02-28 13:22:43 UTC
Not much interest in this topic so far. My take: Wontfix. An extension is a very special solution for a specific use case and the customization is done by installing it. 

But let's keep the issue alive, if a dev wants to look into it.
Comment 3 Cor Nouws 2019-03-01 13:55:18 UTC
(In reply to rolfofsaxony from comment #0)
> However, if you manually create a new menu, using Customise, using the
> macros defined within the extension, in effect, reproducing the extensions
> menu, that menu is written to the above file and becomes customisable.
...
> In my view, Menus and Toolbars delivered with an extension, should be
> available for customisation.
The nature of extensions is: a package that is designed to offer specific features. The storage is different from what you describe above.
So than the idea to customize UI-elements added in extensions to me sounds as a contradiction.
You get my point, rolfofsaxony?
Technically this will be quite some work, I expect.

For the moment I would say: a WontFix.
Comment 4 rolfofsaxony 2019-03-02 11:17:30 UTC
(In reply to Cor Nouws from comment #3)
> (In reply to rolfofsaxony from comment #0)
> > However, if you manually create a new menu, using Customise, using the
> > macros defined within the extension, in effect, reproducing the extensions
> > menu, that menu is written to the above file and becomes customisable.
> ...
> > In my view, Menus and Toolbars delivered with an extension, should be
> > available for customisation.
> The nature of extensions is: a package that is designed to offer specific
> features. The storage is different from what you describe above.
> So than the idea to customize UI-elements added in extensions to me sounds
> as a contradiction.
> You get my point, rolfofsaxony?
> Technically this will be quite some work, I expect.
> 
> For the moment I would say: a WontFix.

I do appreciate that the storage must be different, or I wouldn't have the issue I have, I suspect.

My argument is an argument about consistency.

LibreOffice offers many functions and these functions have options. These Menu and Toolbar options are customiseable. I see no rational for the argument that extensions should not have this feature available to them as well.

An extension may offer many specific features, some of which, the user may or may not want to see/use, just as with the core LibreOffice functions and their options.

For example:
- the extension may offer a toolbar with 10 functions and a menubar with 15 items (10 duplicating the toolbar and 5 that are not consider by the developer to be core)
- the user decides that they only want to see those items on the toolbar that are core to them
- the user decides that one of the menu items not currently on the toolbar is core to them and wishes to add it.
- the user decides that certain items in the menubar they will never be use and does not wish to see them.

It really is about consistentcy within LibreOffice's User Interface.

Regards,
Rolf
Comment 5 rolfofsaxony 2019-03-02 11:22:45 UTC
consistency - suffering from the lack of an edit comment option.
Comment 6 Cor Nouws 2019-03-03 20:08:19 UTC
(In reply to rolfofsaxony from comment #4)
> An extension may offer many specific features, some of which, the user may
> or may not want to see/use, just as with the core LibreOffice functions and
> their options.
From how I see (experience, create) extensions, I really think the likeliness of the wish to change the UI is really small. But of course that may be just me.
A principle problem there is none :) so I won't try to block this.

Note: if there is an extension with a basic library (and I guess the same applies to Python), one already can create a menu-item, button (tool bar) for one or more functions of the extension, which in many situations may lead to the same result.
Comment 7 Muhammet Kara 2019-03-06 13:21:25 UTC
(In reply to Heiko Tietze from comment #1)
> Think this is not possible. What's your take, Muhammet?

Not possible atm. Customize dialog doesn't handle the config part all manually, but relies on the config provider. Needs some checking if it is feasible to add this feature.

And regarding the if-we-should-do-it question:
Customize dialog and the extensions are two ways to customize LibreOffice. The customize dialog is meant to customize the default menus/toolbars etc. Having it won't hurt, but I don't think it is needed. This might be an additional feature for the customize dialog, or even better the job of a different app/extension which is meant to customize/create toolbar/menu extensions.

So, as far as I am concerned, this is a WONTFIX or a low-prio enhancement.